[TOC]

[参考来源](http://blog.csdn.net/onthewaysuccess)

##针孔相机模型

![](./images/camera_corridnate.png)

世界坐标系通过刚体变换到达摄像机坐标系，然后摄像机坐标系通过透视投影变换到达图像坐标系。

- 世界坐标系($X_w, Y_w, Z_w$)

- 摄像机坐标系($X_c, Y_c, Z_c$)

	摄像机坐标系的原点在摄像机的光心上，z轴与摄像机光轴平行。世界坐标系下的物体需先经历刚体变化转到摄像机坐标系，然后在和图像坐标系发生关系。它是图像坐标与世界坐标之间发生关系的纽带，

- 图像坐标系${(x,y)}/{(u,v)}$

	(x,y)坐标系的原点位于摄像机光轴与成像平面的焦点$O^{'}$(u0,v0)上，单位为长度单位(米)。(u,v)坐标系的原点在图片的左上角（其实是存储器的首地址）如上图所示，单位为数量单位(个)。(x,y)主要用于表征物体从摄像机坐标系向图像坐标系的透视投影关系。

$$ u = \frac {x} {dx} + u_0$$
$$ v = \frac {y} {dy} + v_0$$

 **dx代表x轴方向一个像素的宽度，dy代表y轴方向上一个像素的宽度**。dx、dy为摄像机的内参数。(u0,v0)称为图像平面的主点，也是摄像机的内参数。其实相当于对x轴和y轴的离散化。其可以运用齐次坐标，将上式写成矩阵形式，如下：

#####(x,y)变换到(u,v)
$$
\begin{bmatrix}
u \\ v \\ 1	\\
\end{bmatrix}
=
\begin{bmatrix}
\frac {1}{dx} & 0 & u_0\\
0 & \frac {1}{dy} & v_0\\
0 & 0 & 1 \\
\end{bmatrix}
\begin{bmatrix}
x\\y\\1	
\end{bmatrix}
$$

使用齐次坐标的原因：

* 将投影平面扩展到无穷远点。如对消隐点(vanishing point)的描述。

* 使得计算更加规整(齐次坐标有一个重要的性质，伸缩不变性。即：设齐次坐标M，则$αM=M$)

另外一种的推导表达式: [链接](http://www.cnblogs.com/gaoxiang12/p/4652478.html)

#####刚体的旋转平移变换

$$
\begin{bmatrix}
X_c \\ Y_c \\ Z_c	\\
\end{bmatrix}
=
\begin{bmatrix}
r_{00} & r_{01} & r_{02}\\
r_{10} & r_{11} & r_{12}\\
r_{20} & r_{21} & r_{22} \\
\end{bmatrix}
\begin{bmatrix}
X\\Y\\Z	
\end{bmatrix}
+
\begin{bmatrix}
T_x \\ T_y \\T_z\\	
\end{bmatrix}
$$

$$ X_c = RX + T $$


#####透视投影

![](./images/camera_corridnate2.jpg)

  以图中B($X_B,Y_B$)点为例，在小孔成像摄像机模型下（几何分析的最常用模型）。这里的f为摄像机的焦距，其属于摄像机的内参数(intrinsic parameter)。其在成像平面上的投影点b($x_b,y_b$)的坐标利用简单的相似三角形比例关系很容易求出：

$$ x_b = \frac {f_x} {Z_B}X_B $$
$$ y_b = \frac {f_y} {Z_B}Y_B $$



![](./images/camera_corridnate1.png)

**这样就实现了三个坐标系之间的变换，从世界坐标系的米制单位变为图像坐标系的像素单位。**

------------------------------

##标定

$$s \cdot m^{'} = A\cdot \left[R|t\right] \cdot M^{'}$$


$$
s \cdot
\begin{bmatrix}
u \\ v \\ 1	\\
\end{bmatrix}
=
\begin{bmatrix}
f_x & \gamma & c_x \\
0 & f_y & c_y \\
0 & 0 & 1 \\
\end{bmatrix}
\cdot
\begin{bmatrix}
r_{11} & r_{12} & r_{13} & r_{14} \\
r_{21} & r_{22} & r_{23} & r_{24} \\
r_{31} & r_{32} & r_{33} & r_{34} \\
r_{41} & r_{42} & r_{43} & r_{44} \\
\end{bmatrix}
\cdot
\begin{bmatrix}
X\\ Y \\ Z	\\ 1 \\
\end{bmatrix}
$$

因为像素不是规规矩矩的正方形，$\gamma$代表像素点在x,y方向上尺度的偏差。

这里还有一个“梗儿”，就是s。它只是为了方便运算，对于齐次坐标，尺度因子不会改变坐标值的。

**因为标定物是平面，所以我们可以把世界坐标系构造在Z=0的平面上。然后进行单应性计算。令Z=0可以将上式转换为如下形式：**

$$
s
\begin{bmatrix}
u \\v \\1 \\
\end{bmatrix}
= A
\begin{bmatrix}
r_1 & r_2 & r_3 & t\\	
\end{bmatrix}
\begin{bmatrix}
X \\ Y \\ 0 \\ 1 	
\end{bmatrix}
= A 
\begin{bmatrix}
r_1 & r_2 & t\\	
\end{bmatrix}
\begin{bmatrix}
X \\ Y \\ 1 \\	
\end{bmatrix}
$$

既然，此变化属于单应性变化。<font color=red>那么我们可以给$A\left[r_1 \quad r_2 \quad t\right]$一个名字：单应性矩阵。并记$ H= A[r_1 \quad  r_2 \quad t]$</font>。

那么现在就有：

$$
s
\begin{bmatrix}
u \\v \\1 \\
\end{bmatrix}
= H
\begin{bmatrix}
X \\ Y \\ 1 \\	
\end{bmatrix}
$$

H是一个3*3的矩阵，并且有一个元素是作为齐次坐标。**因此，H有8个未知量待解。**

(x,y)作为标定物的坐标，可以由设计者人为控制，是已知量(棋盘格的打印出来大小自己决定)。(u,v)是像素坐标，我们可以直接通过摄像机获得(检测特征点)。对于一组对应的$(x,y) \implies(u,v)$我们可以获得两组方程。

现在有8个未知量需要求解，所以我们至少需要八个方程。所以需要四个对应点。**四点即可算出，图像平面到世界平面的单应性矩阵H。**

这也是张氏标定采用四个角点的棋盘格作为标定物的一个原因。

我们可以将单应性矩阵写成三个列向量的形式，即：

$$ H = \left[ h_1 \quad h_2 \quad h_3 \right]$$


#####利用约束条件求解内参数矩阵A

从上面可知，应用4个点我们可以获得单应性矩阵H。但是，H是内参阵和外参阵的合体。我们想要最终分别获得内参和外参。所以需要想个办法，先把内参求出来。然后外参也就随之解出了

$$
\begin{bmatrix}
h_1 & h_2 & h_3
\end{bmatrix}
= \lambda A
\begin{bmatrix}
r_1 & r_2 & t
\end{bmatrix}
$$

从中可以得出下面两个约束条件，这两个约束条件都是围绕着旋转向量来的。

- $r_1,r_2$正交 得：$r_1r_2 = 0$ 。这个很容易理解，因为$r_1,r_2$分别是绕x,y轴旋转的。应用高中立体几何中的两垂直平面上（两个旋转向量分别位于y-z和x-z平面）直线的垂直关系即可轻松推出。

- 旋转向量的模为1，即|$r_1$|=|$r_2$|=1。这个也很容易理解，因为旋转不改变尺度嘛。

通过上面的式子可以将$r_1,r_2$代换为$h_1,h_2$与A的组合进行表达。

$$ r_1 = A^{-1}h_1  \quad r_2 = A^{-1}h_2$$

$$ h_1^TA^{-T}A^{-1}h_2 = 0 $$
$$ h_1^TA^{-T}A^{-1}h_1 = h_2^TA^{-T}A^{-1}h_2 $$

式子中，$h_1,h_2$是通过单应性已经求解出来的。那么未知量就仅仅剩下，内参矩阵A了。内参阵A包含5个参数：$f_x ,f_y  ,c_x，c_y，\gamma$那么如果我们想完全解出这五个未知量，则需要3个单应性矩阵。3个单应性矩阵在2个约束下可以产生6个方程。这样可以解出全部的五个内参了.摄像机的参数还有畸变的参数,这里没有标定,[详见](http://wiki.opencv.org.cn/index.php/Cv%E7%85%A7%E7%9B%B8%E6%9C%BA%E5%AE%9A%E6%A0%87%E5%92%8C%E4%B8%89%E7%BB%B4%E9%87%8D%E5%BB%BA)

我们怎样才能获得三个不同的单应性矩阵呢？答案就是，用三幅标定物平面的照片。我们可以通过改变摄像机与标定板间的相对位置来获得三张不同的照片。（当然也可以用两张照片，但这样的话就要舍弃掉一个内参了γ=0）


$$
A =
\begin{bmatrix}
\alpha & \gamma & u_0 \\
0 & \beta & v_0 \\
0 & 0 & 1 \\
\end{bmatrix}
$$

$$
B = A^TA^{-1} =
\begin{bmatrix}
B_{11} & B_{12} & B_{13} \\	
B_{12} & B_{22} & B_{23} \\	
B_{13} & B_{23} & B_{33} \\	
\end{bmatrix}
=
\begin{bmatrix}
\frac {1}{\alpha^2} & 　-\frac{\gamma}{\alpha^2\beta} & \frac{v_0\gamma - u_0\beta}{\alpha^2\beta} \\	
\frac {\gamma}{\alpha^2\beta} &　\frac{\gamma^2}{\alpha^2\beta^2} + \frac {1}{\beta^2} & -\frac{\gamma(v_0\gamma - u_0\beta)}{\alpha^2\beta^2} - \frac{v_0}{\beta^2} \\	
\frac{\gamma^2}{\alpha^2\beta^2} + \frac {1}{\beta^2} 　& -\frac{\gamma(v_0\gamma - u_0\beta)}{\alpha^2\beta^2} - \frac{v_0}{\beta^2} & \frac{(v_0\gamma - u_0\beta)^2}{\alpha^2\beta^2} + \frac {v_0^2}{\beta^2} + 1\\	
\end{bmatrix}
$$

很容易发现B是一个对称阵，所以B的有效元素只剩下六个（因为有三对对称的元素是相等的，所以只要解得下面的6个元素就可以得到完整的B了），让这六个元素构成向量b。


$$ b = \left[B_{11} ,B_{12}, B_{22},B_{13} ,B_{23},B_{33} \right]^T$$

接下来在做一步纯数学化简：

$$h_i^TBh_j = v_{ij}^Tb $$

$$v_{ij} = \left[ h_{i1}h_{j1} ,  h_{i1}h_{j2} + h_{i2}h_{j1} , h_{i2}h_{j2},  h_{i3}h_{j1} + h_{i1}h_{j3},  h_{i3}h_{j2} +h_{i2}h_{j3} ,  h_{i3}h_{j3} \right]^T$$

利用约束条件可以得到下面，方程组：

$$
\begin{bmatrix}
v_{12}^T\\
(v_{11} - v_{22})^T	
\end{bmatrix}
b = 0
$$

这个方程组的本质和前面那两个用h和A组成的约束条件方程组是一样的。

在此重复一遍解释：如果我们想完全解出这五个未知量，则需要3个单应性矩阵。**(每个单应性矩阵就是一图副像)，可以算出一组$(h_{11},h_{12},\cdots ,h_{33})$**.

3个单应性矩阵在2个约束下可以产生6个方程。这样可以解出全部的五个内参了。大家想一下，我们怎样才能获得三个不同的单应性矩阵呢？答案就是，用三幅标定物平面的照片。我们可以通过改变摄像机与标定板间的相对位置来获得三张不同的照片。（当然也可以用两张照片，但这样的话就要舍弃掉一个内参了γ=0）
通过至少含一个棋盘格的三幅图像，应用上述公式我们就可以估算出B了。得到B后，我们通过cholesky分解 ，就可以轻松地得到摄像机的内参阵A。

####基于内参阵估算外参阵

$$
\begin{bmatrix}
h_1 & h_2 & h_3
\end{bmatrix}
= \lambda A
\begin{bmatrix}
r_1 & r_2 & t
\end{bmatrix}
$$

对上面公式进行化简，可以得到：

$$
r_1 = \lambda A^{-1}h_1
$$
$$
r_2 = \lambda A^{-1}h_2
$$
$$
r_3 = r_1 \times r_2
$$
$$
t = \lambda A^{-1}h_3
$$

其中$ \lambda = \frac {1}{||A^{-1}h_1||} = \frac {1}{||A^{-1}h_2||}$


##注意点

通过张氏标定，我们并不能得到：焦距(f)和像素的物理尺寸($s_x$,$s_y$)两个参数。因为我们在求解内参阵A时，求解出的是$\alpha$和$\beta$。

那么在opencv中，调用的cvCalibrateCamera2时返回的参数中是包含焦距(f)的。Opencv的这个函数也是用了张氏标定法。为什么可以得到f呢？ [讲解](http://blog.csdn.net/onthewaysuccess/article/details/40718251)